' === sendReport.bas =========================================
' This program continuously updates an ADC temperature reading
' from an MCP9700A sensor. Whenever an interrupt occurs, the
' current data is sent to the Pi for conversion and display.

' The companion program is requestReport.py

' === Directives ===
  #com 4                        'specify serial port
  #picaxe 08M2                  'specify processor
  #terminal off                 'disable the terminal window
  #no_data                      'save time downloading
  
' === Constants ====
  symbol   LED = C.0            'debugging LED on pin C.0
  symbol   MCP = C.4            'MCP9700A on pin C.4
  symbol txPin = C.1            'connected to GPIO 15 on Pi

' === Variables ====
  symbol ADCval = w0            'stores raw temperature data
  symbol hiByte = b1            'the high byte of the raw data
  symbol loByte = b0            'the low byte of the raw data
  
' === Begin Main Program =====================================

fvrsetup FVR2048                       'set FVR at 2048mV
adcconfig %011                         'Vref+=FVR, Vref-=0V
setint %00001000, %00001000            'high pulse on pin C.3
setfreq m8
  
pause 100                              'for 9700 startup
  
do
  high LED                             'blink debugging LED
  wait 1                     
  low LED
  
  readadc10 MCP,ADCval                 'fetch raw data
  wait 9                               'slow down abit
loop

' === End Main: Subroutines Follow ===========================

interrupt:                             'send report  
  serout txPin,T9600_8,(hiByte,loByte) '(hiByte first)  
  setint %00001000, %00001000          're-enable interrupt
  return